// Copyright 2011 Boris Kogan (boris@thekogans.net)
//
// This file is part of libthekogans_util.
//
// libthekogans_util is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// libthekogans_util is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with libthekogans_util. If not, see <http://www.gnu.org/licenses/>.

#if defined (TOOLCHAIN_OS_OSX)

#include <CoreFoundation/CoreFoundation.h>
#include "thekogans/util/StringUtils.h"
#include "thekogans/util/NSLogLogger.h"

#if __cplusplus
extern "C" {
#endif // __cplusplus
    
    void NSLog (CFStringRef format, ...);
    void NSLogv (CFStringRef format, va_list args);

#if __cplusplus
}
#endif // __cplusplus

namespace thekogans {
    namespace util {

        void NSLogLogger::Log (
                const std::string & /*subsystem*/,
                ui32 /*level*/,
                const std::string &header,
                const std::string &message) throw () {
            std::string logEntry = FormatString ("%s%s", header.c_str (), message.c_str ());
            NSLog (CFSTR ("%s"), logEntry.c_str ());
        }

    } // namespace util
} // namespace thekogans

#endif // defined (TOOLCHAIN_OS_OSX)
