//
//  CraftClient.swift
//  Craft
//
//  Created by Bilahari on 10/11/17.
//  Copyright © 2017 logitech. All rights reserved.
//

import Foundation
import Starscream

public protocol CraftClientProtocol : class {
    func handleCraftEvent(msg: String);
}

public class CraftClient : NSObject,WebSocketDelegate
{
    private var uuid : String?
    
    var manifestFilePath : String?
    var execName : String?
    var socket : WebSocket?
    public var delegate: CraftClientProtocol?
    
    public func websocketDidConnect(socket: WebSocketClient) {
        print("=> connected");
        if (self.uuid == nil) {
            let uid : String = UUID().uuidString
            self.uuid = uid
        }
        
        let pid : Int32 = ProcessInfo().processIdentifier
        
        let registerJson : NSDictionary  = [
            "message_type": "register",
            "plugin_guid": self.uuid!,
            "PID": pid,
            "execName": self.execName!,
            "manifestPath": self.manifestFilePath!
        ]
        
        var jsonData : Data
        
        do {
            try
              jsonData = JSONSerialization.data(withJSONObject: registerJson, options: .prettyPrinted)
            
        } catch  {
            return
        }
        
        socket.write(data: jsonData)
    }
    
    public func websocketDidDisconnect(socket: WebSocketClient, error: Error?) {
        print("=> disconnected")
    }
    
    public func websocketDidReceiveMessage(socket: WebSocketClient, text: String) {
        self.delegate?.handleCraftEvent(msg:text)
    }
    
    public func websocketDidReceiveData(socket: WebSocketClient, data: Data) {
    }
    
    public override init() {
        super.init()
        self.uuid = nil;
        socket = WebSocket(url: URL(string: "ws://127.0.0.1:10134")!)
        socket?.delegate = self
    }
    
    public func connect(execName:String, manifestPath:String) {
       self.manifestFilePath = manifestPath
       self.execName = execName
       socket?.connect()
    }
}

