//
//  AppDelegate.swift
//  crafttestUI
//
//  Created by Bilahari on 10/12/17.
//  Copyright © 2017 logitech. All rights reserved.
//

import Cocoa
import Craft

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {

    @IBOutlet weak var window: NSWindow!
    @IBOutlet weak var textView: NSTextView!
    
    var client : CraftClient?
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        client = CraftClient()
        client?.delegate = CraftMessageHandlerClass()
        client?.connect(execName: "crafttestUI.app", manifestPath: "")
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }
}

class CraftMessageHandlerClass: NSObject, CraftClientProtocol {
    override init() {
        super.init()
    }
    
    func handleCraftEvent(msg: String) {
        print(msg);
        let appDelagate : AppDelegate? = NSApplication.shared.delegate as? AppDelegate
        
        let output : String = String(format:"=> %@\n", msg)
        let attr : NSAttributedString  = NSAttributedString.init(string: output);
        
        let tv : NSTextView  = (appDelagate?.textView)!
        let ts : NSTextStorage = (tv.textStorage)!;
        ts.append(attr)
        let range : NSRange = NSMakeRange(tv.string.lengthOfBytes(using: .utf8), 0)
        tv.scrollRangeToVisible(range)
    }
}

